/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package es.ua.jtech.spring.mvc;

import es.ua.jtech.spring.datos.ICocheDAO;
import es.ua.jtech.spring.modelo.Coche;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

/**
 *
 * @author especialista
 */
@Controller
public class CocheController {

    @Autowired
    ICocheDAO dao;


    /*---------------------- LISTAR TODOS LOS COCHES  -----------------------------------------*/
    @RequestMapping("/listar.do")
    public String listar(Model modelo) {
        modelo.addAttribute("listado", dao.listar());
        return "listar";
    }

    /*---------------------- ACTUALIZAR COCHE  -----------------------------------------*/
    @RequestMapping(value = "/editar.do", method = RequestMethod.GET)
    public String prepararEditar(Model modelo, @RequestParam(value = "matricula") String matricula) {
        modelo.addAttribute(dao.obtener(matricula));
        return "editar";
    }

    @RequestMapping(value = "/editar.do", method = RequestMethod.POST)
    public String procesarEditar(Coche coche, BindingResult result, Model modelo) {
        if (result.hasErrors()) {
            return "editar";
        } else {
            dao.actualizar(coche);
            return "redirect:listar.do";
        }
    }

    /*-----------------------INSERTAR NUEVO COCHE -------------------------------------*/
    @RequestMapping(value = "/crear.do", method = RequestMethod.GET)
    public String prepararCrear(Model modelo) {
        modelo.addAttribute(new Coche());
        return "crear";
    }

    @RequestMapping(value = "/crear.do", method = RequestMethod.POST)
    public String procesarCrear(Coche coche, BindingResult result, Model modelo) {
        if (result.hasErrors()) {
             return "alta";
        } else {
            return "redirect:listar.do";
        }
    }
}
